// ΍Wn^Obh ݒ
unit UnitZrGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UnitGVar, UnitFunc, UnitGraph ;

type
  TFmZrGrid = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Edit1: TEdit;
    LabelUnit: TLabel;
    RadioGroup2: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Image1: TImage;
    RadioGroup3: TRadioGroup;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox2: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
  private
    { Private 錾 }
    procedure Zahyo ;
    procedure SubYLine(C:TCanvas;t,col:integer;a:double) ;
  public
    { Public 錾 }
    OKflag : Boolean ;
  end;

var
  FmZrGrid: TFmZrGrid;

implementation

{$R *.dfm}

// N
procedure TFmZrGrid.FormShow(Sender: TObject);
begin
   OKflag := False ;
   CheckBox1.Checked := GR_OnOff;
   if (GR_Type) then
      RadioGroup1.ItemIndex := 1
   else
      RadioGroup1.ItemIndex := 0;
   Edit1.Text := FloatToStr(GR_Dist) ;
   if (GR_Sunpo) then
      RadioGroup2.ItemIndex := 1
   else
      RadioGroup2.ItemIndex := 0;

   Edit2.Text := FloatToStr(WR_Ox);
   Edit3.Text := FloatToStr(WR_Oy);
   Edit2.Enabled := False ;
   Edit3.Enabled := False ;
   ComboBox1.ItemIndex := WR_O ;
   if (WR_O = 5) then begin
      Edit2.Enabled := True ;
      Edit3.Enabled := True ;
   end;
   Edit4.Text := FloatToStr(WR_Angle);
   if (WR_axis) then
      RadioGroup3.ItemIndex := 0
   else
      RadioGroup3.ItemIndex := 1;
   ComboBox2.ItemIndex := WR_Unit;

   Zahyo ;
end;

// [OK]
procedure TFmZrGrid.Button1Click(Sender: TObject);
begin
   if (SDbl(Edit1.Text) <= 0.0) then begin
      MessageBeep(Word(-1));
      Edit1.SetFocus;
      exit;
   end;

   GR_OnOff := CheckBox1.Checked ;
   if (RadioGroup1.ItemIndex = 1) then
      GR_Type := True
   else
      GR_Type := False ;
   GR_Dist := SDbl(Edit1.Text);
   if (RadioGroup2.ItemIndex = 1) then
      GR_Sunpo := True
   else
      GR_Sunpo := False ;

   WR_O     := ComboBox1.ItemIndex ;
   WR_Ox    := SDbl(Edit2.Text);
   WR_Oy    := SDbl(Edit3.Text);
   WR_Angle := SDbl(Edit4.Text);
   if (RadioGroup3.ItemIndex = 0) then
      WR_axis := True
   else
      WR_axis := False ;
   WR_Unit  := ComboBox2.ItemIndex ;
   if (WR_Unit >= 0)and(WR_Unit < 7) then
      WR_UnitS := ComboBox2.Items[WR_Unit]
   else
      WR_UnitS := '';

   OKflag := True ;
   close ;
end;

// [LZ]
procedure TFmZrGrid.Button2Click(Sender: TObject);
begin
   close ;
end;

// _
procedure TFmZrGrid.ComboBox1Click(Sender: TObject);
var
   i : integer ;
   x,y : double ;
begin
   i := ComboBox1.ItemIndex ;
   Edit2.Enabled := False ;
   Edit3.Enabled := False ;
   x := 0.0;
   y := 0.0;
   Case(i)of
   1: begin
         x := -PA_x/2.0 ;
         y := -PA_y/2.0 ;
      end;
   2: begin
         x :=  PA_x/2.0 ;
         y := -PA_y/2.0 ;
      end;
   3: begin
         x := -PA_x/2.0 ;
         y :=  PA_y/2.0 ;
      end;
   4: begin
         x :=  PA_x/2.0 ;
         y :=  PA_y/2.0 ;
      end;
   5: begin
         x := SDbl(Edit2.Text);
         y := SDbl(Edit3.Text);
         Edit2.Enabled := True ;
         Edit3.Enabled := True ;
      end;
   end;
   Edit2.Text := FloatToStr(x);
   Edit3.Text := FloatToStr(y);
end;

// Wn\
procedure TFmZrGrid.Zahyo ;
var
   a : double ;
begin
   G_CLS(Image1.Canvas,0,0,80,80);
   a := SDbl(Edit4.Text);
   if (RadioGroup3.ItemIndex = 0) then begin
      // XY
      SubYLine(Image1.Canvas,0,clBlue,a) ;      // X
      SubYLine(Image1.Canvas,1,clRed ,a+90) ;   // Y
   end
   else begin
      // YX
      SubYLine(Image1.Canvas,1,clRed ,a) ;      // Y
      SubYLine(Image1.Canvas,0,clBlue,a+90) ;   // X
   end;
end;

// `
procedure TFmZrGrid.SubYLine(C:TCanvas;t,col:integer;a:double) ;
var
   x1,y1,x2,y2 : integer ;
begin
   with C do begin
      Pen.Mode := pmCopy ;
      Pen.Color := col ;
      Pen.Width := 3 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      x1 := 40 ;
      y1 := 40 ;
      x2 := 40 + Round(25.0*Cos(a/180.0*Pi));
      y2 := 40 - Round(25.0*Sin(a/180.0*Pi));
      C.MoveTo(x1,y1);
      C.LineTo(x2,y2);
      x1 := x2 ;
      y1 := y2 ;
      x2 := x1 + Round(8.0*Cos((a+135)/180.0*Pi));
      y2 := y1 - Round(8.0*Sin((a+135)/180.0*Pi));
      C.MoveTo(x1,y1);
      C.LineTo(x2,y2);
      x2 := x1 + Round(8.0*Cos((a-135)/180.0*Pi));
      y2 := y1 - Round(8.0*Sin((a-135)/180.0*Pi));
      C.MoveTo(x1,y1);
      C.LineTo(x2,y2);
      Font.Name := 'lr SVbN';
      Font.Size := 12 ;
      Font.Color:= col;
      x1 := 40 + Round(35.0*Cos(a/180.0*Pi)) - 6;
      y1 := 40 - Round(35.0*Sin(a/180.0*Pi)) - 6;
      if (t = 0) then begin
         TextOut(x1,y1,'w');
      end
      else begin
         TextOut(x1,y1,'x');
      end;
   end;
end;

// W
procedure TFmZrGrid.RadioGroup3Click(Sender: TObject);
begin
   Zahyo ;
end;

// Xpx
procedure TFmZrGrid.Edit4Change(Sender: TObject);
begin
   Zahyo ;
end;

end.
